***** SUBROUTINE SCALE                            Last Update: 29-Jan-03
C
C     For a given input value YIN, programme returns a "reasonable"
C     scaling value YOUT.
C     The parameter TOL controls the scaling process.
C
      Subroutine SCALE(yout,yin)
      Implicit   Real*8(D-H,O-Z)
      Parameter (tol=1.2d0)
      Character  z_val*10,z_cut*6,z_dec*5
C
      val = abs(yin)
      write (z_val,'(1PG10.3)') val
      ipkt = index(z_val,'.')
      z_cut =  z_val(1:ipkt+1)
      read (z_cut,'(f6.0)') valst
      valst = valst*tol
      z_dec(2:5) = z_val(7:10)
      z_dec(1:1) = '1'
      read (z_dec,'(f5.0)') valdec
      ivalr = 0
      if (abs(valst) .lt. 1d0) then
          z_cut = z_val(ipkt+1:ipkt+1)
          read (z_cut,'(I6)') ivalst
          ivalr = mod(ivalst,2)
          if (ivalr .eq. 1) then
              ivalst = ivalst+ivalr
          else
              ivalst = ivalst+2
          end if
          valst = dfloat(ivalst)*1d-1
      else if (abs(valst) .ge. 1d0 .and.
     #         abs(valst) .lt. 1d1) then
          z_cut = z_val(ipkt-1:ipkt-1)
          read (z_cut,'(I6.0)') ivalst
          ivalr = mod(ivalst,2)
          if (ivalr .eq. 1) then
              ivalst = ivalst+ivalr
          else
              ivalst = ivalst+2
          end if
          valst = dfloat(ivalst)
      else if (abs(valst) .gt. 1d1 .and.
     #         abs(valst) .lt. 1d2) then
          z_cut = z_val(ipkt-2:ipkt-2)
          read (z_cut,'(I6)') ivalst
          ivalr = mod(ivalst,2)
          if (ivalr .eq. 1) then
              ivalst = ivalst+ivalr
          else
              ivalst = ivalst+2
          end if
          valst = dfloat(ivalst)*1d1
      else if (abs(valst) .gt. 1d2 .and.
     #         abs(valst) .lt. 1d3) then
          z_cut = z_val(ipkt-3:ipkt-3)
          read (z_cut,'(I6)') ivalst
          ivalr = mod(ivalst,2)
          if (ivalr .eq. 1) then
              ivalst = ivalst+ivalr
          else
              ivalst = ivalst+2
          end if
          valst = dfloat(ivalst)*1d2
      end if
      yout = valst*valdec
      return
      end
